package ru.myitschool.work.data.network

import io.ktor.client.call.body
import io.ktor.client.request.get
import io.ktor.client.request.headers
import io.ktor.http.HttpHeaders
import io.ktor.http.HttpStatusCode
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.withContext
import ru.myitschool.work.core.Constants
import ru.myitschool.work.data.dto.UserDto

object UserNetworkDataSource {

    suspend fun isUserExist(login: String): Result<Boolean> = withContext(Dispatchers.IO) {
        runCatching {
            val result = KtorClient.client.get("${Constants.SERVER_ADDRESS}/api/users/username/$login")
            result.status == HttpStatusCode.OK
        }
    }

    suspend fun login(token: String): Result<UserDto> =
        withContext(Dispatchers.IO) {
            runCatching {
                val result = KtorClient.client.get("${Constants.SERVER_ADDRESS}/api/users/login") {
                    headers {
                        append(HttpHeaders.Authorization, token)
                    }
                }
                if (result.status != HttpStatusCode.OK)
                    error("Status ${result.status}")
                result.body()
            }
        }

    suspend fun getUserByLogin() {}
}